/* Java */
import java.io.*;
import java.util.*;

public class monitor {

	public static void main(String[] args) throws Exception{
		File filein = new File("monitor.in");
		File fileout = new File("monitor.out");
		if(!fileout.exists()) {
			fileout.createNewFile();
		}
		Scanner scr = new Scanner(filein);
		PrintWriter wrt = new PrintWriter(fileout);
		int m = scr.nextInt();
		int n = scr.nextInt();
		int w = scr.nextInt();
		int h = scr.nextInt();
		int k = scr.nextInt();
		int[][] screen = new int [m][n];
		for(int i = 0; i < m; i++) {
			for(int j = 0; j < n; j++) {
				screen[i][j] = 0; 
			}
		}
		for(int i = 0; i < k; i++) {
			fill(screen, scr.nextInt(), scr.nextInt(), scr.nextInt(), w, h);
		}
		for(int i = 0; i < n; i++) {
			for(int j = 0; j < m - 1; j++) {
				wrt.print(screen[j][i] + " ");
			}
			wrt.println(screen[m-1][i]);
		}
		scr.close();
		wrt.close();
	}
	public static void fill(int[][] array, int x, int y, int color, int w, int h) {
		for(int i = x; i < x + w; i++) {
			for(int j = y; j < y + h; j++) {
				array[i][j] = color;
			}
		}
	}
}
